(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@wm/components/base'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.containers = global.wm.components.containers || {}, global.wm.components.containers.tile = {}), global.ng.core, global.ng.common, global.wm.components.base));
})(this, (function (exports, i0, common, base) { 'use strict';

    function _interopNamespaceDefault(e) {
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n.default = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespaceDefault(i0);

    const registerProps = () => {
        base.register('wm-tile', new Map([
            ['animation', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['name', base.PROP_STRING],
            ['show', { value: true, ...base.PROP_BOOLEAN }]
        ]));
    };

    const DEFAULT_CLS = 'app-tile';
    const WIDGET_CONFIG = { widgetType: 'wm-tile', hostClass: DEFAULT_CLS };
    class TileDirective extends base.StylableComponent {
        static { this.initializeProps = registerProps(); }
        constructor(inj, explicitContext) {
            super(inj, WIDGET_CONFIG, explicitContext);
            base.styler(this.nativeElement, this, base.APPLY_STYLES_TYPE.CONTAINER);
        }
        static { this.ɵfac = function TileDirective_Factory(t) { return new (t || TileDirective)(i0__namespace.ɵɵdirectiveInject(i0__namespace.Injector), i0__namespace.ɵɵdirectiveInject('EXPLICIT_CONTEXT', 8)); }; }
        static { this.ɵdir = /*@__PURE__*/ i0__namespace.ɵɵdefineDirective({ type: TileDirective, selectors: [["", "wmTile", ""]], features: [i0__namespace.ɵɵProvidersFeature([
                    base.provideAsWidgetRef(TileDirective)
                ]), i0__namespace.ɵɵInheritDefinitionFeature] }); }
    }
    (() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(TileDirective, [{
            type: i0.Directive,
            args: [{
                    selector: '[wmTile]',
                    providers: [
                        base.provideAsWidgetRef(TileDirective)
                    ]
                }]
        }], () => [{ type: i0__namespace.Injector }, { type: undefined, decorators: [{
                    type: i0.Inject,
                    args: ['EXPLICIT_CONTEXT']
                }, {
                    type: i0.Optional
                }] }], null); })();

    const components = [
        TileDirective
    ];
    class TileModule {
        static { this.ɵfac = function TileModule_Factory(t) { return new (t || TileModule)(); }; }
        static { this.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: TileModule }); }
        static { this.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [common.CommonModule,
                base.WmComponentsModule] }); }
    }
    (() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(TileModule, [{
            type: i0.NgModule,
            args: [{
                    imports: [
                        common.CommonModule,
                        base.WmComponentsModule
                    ],
                    declarations: [...components],
                    exports: [...components]
                }]
        }], null, null); })();
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(TileModule, { declarations: [TileDirective], imports: [common.CommonModule,
            base.WmComponentsModule], exports: [TileDirective] }); })();

    exports.TileDirective = TileDirective;
    exports.TileModule = TileModule;

}));
